=== doc/requirements.txt ===
breathe
sphinx-book-theme
sphinx-design
sphinxcontrib-bibtex
numpy
ase
cffi
