=== subprojects/mctc-lib/meson_options.txt ===
# This file is part of mctc-lib.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

option(
  'openmp',
  type: 'boolean',
  value: false,
  yield: true,
  description: 'use OpenMP parallelisation',
)

option(
  'json',
  type: 'feature',
  value: 'auto',
  yield: true,
  description: 'support JSON input',
)
